<?php
////////////////////////////////////////////////////////////////////////////////
//   Copyright (C) ReloadCMS Development Team                                 //
//   http://reloadcms.sf.net                                                  //
//                                                                            //
//   This program is distributed in the hope that it will be useful,          //
//   but WITHOUT ANY WARRANTY, without even the implied warranty of           //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     //
//                                                                            //
//   This product released under GNU General Public License v2                //
////////////////////////////////////////////////////////////////////////////////  
// setup section 
   $nf_path=DATA_PATH."/tmp-ip/";
   $nf_fip=$nf_path.getenv("REMOTE_ADDR");
   $nf_fcron=$nf_path.".time";

   //   => -
   //
   //            , 
   //       
   //
   $nf_flood=array(
      10   => 2,      //   10   10 
      60   => 12,      //   30   
      300  => 50,      //   50   5 
      3600 => 200,     //   200   
   );

   $nf_cron_run=1200; //       

   $nf_old_file=7200; //       ( )



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
   


function cron_update($fn,$update) {

   if (!file_exists($fn)) {
      if (!@touch($fn)) {
         echo "   <b>".basename($fn)."</b>,     (w+)<br>";
         return -1;
      }
   }
   else { 
      if (time()-filemtime($fn)<$update) {return 0;}
   }
   
   $f=@fopen($fn,"r+");
   if (!$f) {
      echo "   <b>".basename($fn)."</b>,     (r+)<br>";
      return -1;
   }
   if (!flock($f,6)) {return;}
   $text=fgets($f,100);
   if (time()-intval($text)<$update) {return 0;}
   fseek($f,0,SEEK_SET);
   fwrite($f,time()."    ");
   fclose($f);

   return 1;

}


   $nf_cron_code=cron_update($nf_fcron,$nf_cron_run);
   if ($nf_cron_code==-1) return;
   if ($nf_cron_code==1) {
      if ($nf_dir=@opendir($nf_path)) {
         $nf_time=time()-$nf_old_file;
         while (($nf_tmp=readdir($nf_dir))!==false) {
            if ($nf_tmp[0]==".") continue;
            if (filemtime($nf_path.$nf_tmp)<$nf_time && 
               preg_match("!^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$!",$nf_tmp))
            {
               if (!unlink($nf_path.$nf_tmp)) {
                  echo "   <b>$nf_tmp</b><br>";
               }
            }
         }
         closedir($nf_dir);
      }
   }
   unset($nf_cron_code);


   if (file_exists($nf_fip)) {
      $nf_f=@fopen($nf_fip,"r+");
      if (!flock($nf_f,6)) exit("Parallel processing disable.");
      if (!$nf_f) {
         echo "   <b>".basename($nf_fip)."</b> (r+)<br>";
         return;
      }
      $nf_buf=fgets($nf_f,1000);
      $nf_buf=explode("|",$nf_buf);
   }
   else {
      for ($nf_i=0; $nf_i<count($nf_flood)*2; $nf_i++) $nf_buf[]=0;
      $nf_f=@fopen($nf_fip,"a+");
      if (!$nf_f) {
         echo "   <b>".basename($nf_fip)."</b> (a+)<br>";
         return;
      }
      if (!flock($nf_f,6)) exit("Parallel processing disable.");
   }


   $nf_i=0;
   $nf_stopflag=0;

   //echo "<pre>";print_r($nf_buf);

   foreach ($nf_flood as $nf_k=>$nf_v) {
      if ($nf_buf[$nf_i+1]+$nf_k<time()) { 
         $nf_buf[$nf_i]=1;
         $nf_buf[$nf_i+1]=time();
      }
      else {
         if ($nf_buf[$nf_i]>$nf_v) {
            $nf_stopflag=1;
            $nf_buf[$nf_i+1]=time();
         }
         $nf_buf[$nf_i]++;
      }
      $nf_i+=2;
   }


   ftruncate($nf_f,0);
   fseek($nf_f,0);
   fputs($nf_f,implode("|",$nf_buf));

   //print_r($nf_buf);
   if ($nf_stopflag) exit("");
   
   unset($nf_f);
   unset($nf_i);
   unset($nf_k);
   unset($nf_v);
   unset($nf_stopflag);
   unset($nf_buf);
   unset($nf_fip);
   unset($nf_path);
   unset($nf_flood);
   unset($nf_cron_run);
   unset($nf_cron_idle);

?>