<?php
////////////////////////////////////////////////////////////////////////////////
//   Copyright (C) ReloadCMS Development Team                                 //
//   http://reloadcms.sf.net                                                  //
//                                                                            //
//   This program is distributed in the hope that it will be useful,          //
//   but WITHOUT ANY WARRANTY, without even the implied warranty of           //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     //
//                                                                            //
//   This product released under GNU General Public License v2                //
////////////////////////////////////////////////////////////////////////////////
$weblinks = new weblinks(WEBLINKS_DATA);

// Creating new web link
if(!empty($_POST['newsave'])){
    
    // And trying to save it to database
    if($weblinks->createFile($_POST['newsave']-1, @$_POST['title'], @$_POST['desc'], @$_POST['url'])) {
        rcms_showAdminMessage(__('Link added'));
    } else rcms_showAdminMessage(__('Error occurred'));
} elseif(!empty($_POST['delete']) && is_array($_POST['delete']) && !empty($_POST['cid'])) {
    $result = '';
    $cid = (int) $_POST['cid']-1;
    foreach ($_POST['delete'] as $fid => $cond){
        if(!empty($cond)){
            if($weblinks->deleteFile($cid, $fid)) {
                $result .= __('Link removed') . ' (' . $cid . ':' . $fid . ')<br>';
            } else {
                $result .= __('Error occurred') . ' (' . $cid . ':' . $fid . ')<br>';
            }
        }
    }
    rcms_showAdminMessage($result);
    unset($_POST['edit']);
} elseif (!empty($_POST['edit']) && !empty($_POST['save']) && !empty($_POST['cid'])){
    $_POST['edit'] = $_POST['edit'] - 1;
    if($weblinks->updateFile($_POST['cid']-1, $_POST['edit'], @$_POST['title'], @$_POST['desc'], @$_POST['url'])) {
        rcms_showAdminMessage(__('Link updated'));
    } else rcms_showAdminMessage(__('Error occurred'));
}

////////////////////////////////////////////////////////////////////////////////
// Interface generation                                                       //
////////////////////////////////////////////////////////////////////////////////
if(!empty($_POST['new'])){
    $frm = new InputForm ('', 'post', '&lt;&lt;&lt; ' . __('Back')); $frm->hidden('cid', $_POST['new']); $frm->show();
    $frm = new InputForm ('', 'post', __('Submit'));
    $frm->addbreak(__('New link'));
    $frm->hidden('newsave', $_POST['new']);
    $frm->hidden('cid', $_POST['new']);
    $frm->addrow(__('Title'), $frm->text_box('title', ''));
    $frm->addrow(__('Description'), $frm->textarea('desc', ''));
    $frm->addrow(__('URL address'), $frm->text_box('url', ''));
    $frm->show();
} elseif(!empty($_POST['edit']) && !empty($_POST['cid']) && !empty($weblinks->data[$_POST['cid']-1]['files'][$_POST['edit']-1])){
    $cid = $_POST['cid'] - 1;
    $fid = $_POST['edit'] - 1;
    $frm = new InputForm ('', 'post', '&lt;&lt;&lt; ' . __('Back')); $frm->hidden('cid', $_POST['cid']); $frm->show();
    $frm = new InputForm ('', 'post', __('Submit'));
    $frm->addbreak(__('Edit link'));
    $frm->hidden('save', '1');
    $frm->hidden('edit', $_POST['edit']);
    $frm->hidden('cid', $_POST['cid']);
    $frm->addrow(__('Title'), $frm->text_box('title', $weblinks->data[$cid]['files'][$fid]['name']));
    $frm->addrow(__('Description'), $frm->textarea('desc', $weblinks->data[$cid]['files'][$fid]['desc']));
    $frm->addrow(__('URL address'), $frm->text_box('url', $weblinks->data[$cid]['files'][$fid]['url']));
    $frm->show();
} elseif(!empty($_POST['cid'])) {
    $frm = new InputForm ('', 'post', '&lt;&lt;&lt; ' . __('Back')); $frm->show();
    $frm = new InputForm ('', 'post', __('New link')); $frm->hidden('new', $_POST['cid']); $frm->show();
    if(!empty($weblinks->data[$_POST['cid']-1]['files'])){
        $frm = new InputForm ('', 'post', __('Submit'), __('Reset'));
        $frm->hidden('cid', $_POST['cid']);
        foreach ($weblinks->data[$_POST['cid']-1]['files'] as $fid => $fdata){
            $frm->addrow($fdata['url'] . '<br>' . $fdata['name'] . ' (' . $fdata['desc'] . '). ',
                $frm->checkbox('delete[' . $fid . ']', '1', __('Delete')) . ' ' .
                $frm->radio_button('edit', array($fid+1 => __('Edit')), 0), 'top'
            );
        }
        $frm->show();
   }
} else {
    $clist = array();
    foreach ($weblinks->data as $cid => $cdata) $clist[$cid+1] = $cdata['name'];
    if(!empty($clist)){
        $frm =new InputForm ('', 'post', __('Browse'));
        $frm->addrow(__('Select category'), $frm->select_tag('cid', $clist));
        $frm->show();
    } else rcms_showAdminMessage( __('There is no categories there'));
}
$weblinks->close();
?>
