<?php
////////////////////////////////////////////////////////////////////////////////
//   Copyright (C) ReloadCMS Development Team                                 //
//   http://reloadcms.sf.net                                                  //
//                                                                            //
//   This program is distributed in the hope that it will be useful,          //
//   but WITHOUT ANY WARRANTY, without even the implied warranty of           //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     //
//                                                                            //
//   This product released under GNU General Public License v2                //
////////////////////////////////////////////////////////////////////////////////
$weblinks = new weblinks(WEBLINKS_DATA);
$cid = (!empty($_GET['id'])) ? (int)$_GET['id'] - 1 : -1;
$fid = (!empty($_GET['fid'])) ? (int)$_GET['fid'] - 1 : -1;

if(!empty($_GET['get']) && $cid >= 0 && $fid >= 0 && !empty($weblinks->data[$cid]['files'][$fid])) {
    $cdata = &$weblinks->data[$cid];
    if(@$cdata['accesslevel'] > @$system->user['accesslevel'] && !$system->checkForRight('-any-')) {
        show_error(__('Access denied'));
    } else {
        $fdata = &$weblinks->data[$cid]['files'][$fid];
        @$fdata['count']++;
        $weblinks->close();
        $url = (basename($fdata['url']) == $fdata['url']) ? FILES_PATH . $fdata['url'] : $fdata['url'];
        header('Location: ' . $url);
        die('Redirection to <a href="' . $url . '">' . $fdata['url'] . '</a>');
    }
} elseif($cid >= 0 && $fid >= 0 && !empty($weblinks->data[$cid]['files'][$fid])) {
    $cdata = &$weblinks->data[$cid];
    if(@$cdata['accesslevel'] > @$system->user['accesslevel'] && !$system->checkForRight('-any-')) {
        show_error(__('Access denied'));
    } else {
        $system->config['pagename'] = $weblinks->data[$cid]['files'][$fid]['name'];
        $result = '';
        if(!empty($weblinks->data[$cid]['files'][$fid])){
            $fdata = $weblinks->data[$cid]['files'][$fid];
            $fdata['down_url'] = '?module=' . $module . '&amp;id=' . ($cid+1) . '&amp;fid=' . ($fid+1) . '&amp;get=1';
            $result .= rcms_parse_module_template('weblinks-link.tpl', $fdata);
        }
        show_window('<a href="?module=' . $module .  '">' . __('Categories of links') . '</a> -&gt; ' . '<a href="?module=' . $module . '&amp;id=' . ($cid + 1) . '">' . $weblinks->data[$cid]['name'] . '</a>', $result, 'center');
    }
} elseif($cid >= 0 && !empty($weblinks->data[$cid])) {
    $cdata = &$weblinks->data[$cid];
    if(@$cdata['accesslevel'] > @$system->user['accesslevel'] && !$system->checkForRight('-any-')) {
        show_error(__('Access denied'));
    } else {
        $system->config['pagename'] = $weblinks->data[$cid]['name'];
        $result = '';
        foreach ($weblinks->data[$cid]['files'] as $fid=>$fdata){
            $weblinks->data[$cid]['files'][$fid]['id'] = $fid;
        }
        $data = array_reverse($weblinks->data[$cid]['files']);
        if(!empty($data)){
            if(!empty($system->config['perpage'])) {
                $pages = ceil(sizeof($data)/$system->config['perpage']);
                if(!empty($_GET['page']) && ((int) $_GET['page']) > 0) $page = ((int) $_GET['page'])-1; else $page = 0;
                $start = $page * $system->config['perpage'];
                $total = $system->config['perpage'];
            } else {
                $pages = 1;
                $page = 0;
                $start = 0;
                $total = sizeof($data);
            }
            if(($total + $start) > sizeof($data)) {
                $finish = sizeof($data);
            } else {
                $finish = $total + $start;
            }
            $result .= '<div align="right">' . rcms_pagination(sizeof($data), $system->config['perpage'], $page+1, '?module=' . $module . '&amp;id=' . ($cid + 1)) . '</div>';
            for ($fid = $start; $fid < $finish; $fid++){
                $fdata = $data[$fid];
                $fdata['down_url'] = '?module=' . $module . '&amp;id=' . ($cid+1) . '&amp;fid=' . ($fdata['id']+1) . '&amp;get=1';
                if(!empty($fdata)) $result .= rcms_parse_module_template('weblinks-link.tpl', $fdata);
            }
        }
        show_window('<a href="?module=' . $module .  '">' . __('Categories of links') . '</a> -&gt; ' . $weblinks->data[$cid]['name'], $result, 'center');
    }
} else {
    $system->config['pagename'] = __('Categories of links');
    if(!empty($weblinks->data)){
        $result = '';
        foreach ($weblinks->data as $cid => $cdata){
            if(@$cdata['accesslevel'] <= @$system->user['accesslevel'] || $system->checkForRight('-any-')) {
                $result .= rcms_parse_module_template('weblinks-cat.tpl', $cdata + array('url' => '?module=' . $module . '&amp;id=' . ($cid + 1)));
            }
        }
        show_window(__('Categories of links'), $result, 'center');
    } else show_error(__('There is no categories of links'));
}
?>
